3 ### Build script for Debian packages
5 ### (c) 2008 Mark Wooding
8 ###----- Licensing notice ---------------------------------------------------
10 ### This program is free software; you can redistribute it and/or modify
11 ### it under the terms of the GNU General Public License as published by
12 ### the Free Software Foundation; either version 2 of the License, or
13 ### (at your option) any later version.
15 ### This program is distributed in the hope that it will be useful,
16 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18 ### GNU General Public License for more details.
20 ### You should have received a copy of the GNU General Public License
21 ### along with this program; if not, write to the Free Software Foundation,
22 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
24 ###--------------------------------------------------------------------------
25 ### Conventions for build systems.
27 ### This script is designed to work with a variety of `make'-based build
28 ### systems, but there are a number of conventions which must be followed if
29 ### this is going to work properly.
31 ### * There must be a `configure.ac', `configure.in', or `.links' file, or
32 ### a `.git' directory in the project top-level, so that we can find it.
34 ### * The following `make' variables must be assigned in the top-level
35 ### Makefile, after `mdw-build' has constructed it.
37 ### distdir The name of the top-level project directory in the
38 ### source distribution, and the base name for
39 ### distribution archives; should be of the form
40 ### `PROJECT-VERSION'.
42 ### The following `make' targets must be available in the top-level
45 ### dist Write to $(distdir).tar.gz a source distribution of
48 ### distcheck As for `dist', but also build and test the project.
50 ### * The source distribution constructed by `make dist' must contain a file
51 ### $(distdir)/RELEASE containing the release name. This isn't currently
52 ### tested, but it might be later.
56 ###--------------------------------------------------------------------------
63 Usage: $prog [-vr] BUILDOPT
79 ## Parse simple options.
81 while getopts "hvr" opt; do
90 ## Parse the build options.
104 checkout) checkout=yes checkoutrev=HEAD ;;
105 checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
106 release) build=release ;;
107 norelease) build=test ;;
108 setup) setup=yes setupcmd=mdw-setup ;;
109 setup=*) setup=yes setupcmd=${opt#*=} ;;
111 distcheck | debian | upload | clean | vpath | native)
114 nocheckout | nosetup | nodistcheck | nodebian | \
115 noupload | noclean | novpath | nonative)
125 ## Parse DEB_BUILD_OPTIONS.
127 set -- $DEB_BUILD_OPTIONS
130 parallel=*) jobs=${opt#*=} ;;
135 case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
137 ###--------------------------------------------------------------------------
138 ### Utility functions.
140 exec 3>&2 4>/dev/null 5>&2
145 echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&5
155 release) fail "$*" ;;
156 *) notify 5 "??? $*" ;;
171 "$@" 2>&3 || fail "$1: exit $?"
174 run () { runx "$@" >&3; }
177 echo -n "(test $*)" >&4
178 if "$@" >&4 2>&4; then
187 ###--------------------------------------------------------------------------
190 ## Find the top-level package directory.
191 while [ ! -f configure.ac -a ! -f configure.in -a \
192 ! -f .links -a ! -d .git ]; do
195 fail "couldn't find top-level directory"
200 assign srcpath $(pwd)
202 ## Build any necessary qualifiers.
204 case ${SBOX_SESSION_DIR+t},${DEB_BUILD_ARCH+t} in
205 t,t) qual=$qual$sep$DEB_BUILD_ARCH; sep=- ;;
206 t,*) fail "unknown build arch" ;;
209 ## Construct the output directory.
210 assign releasepath $srcpath/dist-$build$qual
211 chmod -R +w $releasepath 2>/dev/null || :
212 rm -rf $releasepath 2>/dev/null || :
216 exec 4>$releasepath/mdw-build.log 3>&4 ||
217 fail "Failed to create log."
221 ## Do we have a Git repository?
222 case "$checkout,$setup,$(yesno [ -d $srcpath/.git ])" in
224 fail "Inconsistent options: can't check out without setup."
227 info "No Git repository found."
228 checkout=no gitver=none
232 [ "$(git ls-files -m)" = "" ] ||
233 warn "working tree has uncommitted changes"
237 ## Is there Debian build equipment?
238 case "$debian,$(yesno [ -d $srcpath/debian ])" in
240 info "No debian directory found."
241 debian=no debver=none
247 debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p' | tr \~ -)
248 debsrc=$(dpkg-parsechangelog | sed -n 's/^Source: //p')
249 debname=$(git config user.name) debemail=$(git config user.email)
253 ## Maybe check out a copy of the source.
257 run git clone -sn $srcpath/.git _source
258 assign srcpath $releasepath/_source
260 run git checkout -b mdw-build $checkoutrev
261 gitver=$(git describe --abbrev=4)
265 ## Check the version number.
267 case "$gitver,$debver" in
271 if [ "$gitver" != "$debver" ]; then
272 warn "Git version $gitver doesn't match Debian version $debver"
278 ## Maybe refresh the build machinery.
285 ## Initialize the build directory.
286 case "$vpath,$(yesno [ -e $srcpath/configure ])" in
288 assign buildpath $releasepath/_build
291 run $srcpath/configure
294 info "VPATH build disabled"
295 assign buildpath $srcpath
301 info "no configure script"
302 assign buildpath $srcpath
307 ## Discover the release name.
308 cat >find-distdir.mk <<'EOF'
314 $({ make -f find-distdir.mk print-distdir >/dev/null 2>&1; } 3>&1)
316 ## Get a tarball distribution.
319 run make $makeopts distcheck
322 run make $makeopts dist
330 if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE
332 fail "missing RELEASE file in distribution"
337 run mv $buildpath/$distdir.tar.gz .
340 run gpg -u$(mdw-conf releasekey) -ab -o$distdir.tar.gz.gpg \
345 ## Maybe build the Debian packages.
348 run tar xvfz $distdir.tar.gz
352 dver=$(echo $gitver | sed 's/-/+/; s/-/./g')
354 cat - debian/changelog >debian/changelog.new <<EOF
355 $debsrc ($dver) experimental; urgency=low
357 * Hacking in process, not intended for release.
359 -- $debname <$debemail> $now
362 mv debian/changelog.new debian/changelog
365 run dpkg-buildpackage -k$(mdw-conf releasekey)
369 ## Maybe upload Debian packages.
371 case "$upload,$build" in
373 info "Test build: not uploading."
376 run rsync $distdir.tar.gz $distdir.tar.gz.gpg \
377 $(mdw-conf upload-target ftp.distorted.org.uk:~ftp/pub/mdw/)
380 run dput -f $(mdw-conf dput-target distorted) *.changes
388 rm -rf $releasepath/$distdir
389 rm -rf $releasepath/_source
390 rm -rf $releasepath/_build
397 ###----- That's all, folks --------------------------------------------------